<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfIncreasedPricesInformation ArrayType
 * @subpackage Arrays
 */
class ArrayOfIncreasedPricesInformation extends AbstractStructArrayBase
{
    /**
     * The IncreasedPricesInformation
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IncreasedPricesInformation[]
     */
    public $IncreasedPricesInformation;
    /**
     * Constructor method for ArrayOfIncreasedPricesInformation
     * @uses ArrayOfIncreasedPricesInformation::setIncreasedPricesInformation()
     * @param \StructType\IncreasedPricesInformation[] $increasedPricesInformation
     */
    public function __construct(array $increasedPricesInformation = array())
    {
        $this
            ->setIncreasedPricesInformation($increasedPricesInformation);
    }
    /**
     * Get IncreasedPricesInformation value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IncreasedPricesInformation[]|null
     */
    public function getIncreasedPricesInformation()
    {
        return isset($this->IncreasedPricesInformation) ? $this->IncreasedPricesInformation : null;
    }
    /**
     * This method is responsible for validating the values passed to the setIncreasedPricesInformation method
     * This method is willingly generated in order to preserve the one-line inline validation within the setIncreasedPricesInformation method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateIncreasedPricesInformationForArrayConstraintsFromSetIncreasedPricesInformation(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfIncreasedPricesInformationIncreasedPricesInformationItem) {
            // validation for constraint: itemType
            if (!$arrayOfIncreasedPricesInformationIncreasedPricesInformationItem instanceof \StructType\IncreasedPricesInformation) {
                $invalidValues[] = is_object($arrayOfIncreasedPricesInformationIncreasedPricesInformationItem) ? get_class($arrayOfIncreasedPricesInformationIncreasedPricesInformationItem) : sprintf('%s(%s)', gettype($arrayOfIncreasedPricesInformationIncreasedPricesInformationItem), var_export($arrayOfIncreasedPricesInformationIncreasedPricesInformationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The IncreasedPricesInformation property can only contain items of type \StructType\IncreasedPricesInformation, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set IncreasedPricesInformation value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\IncreasedPricesInformation[] $increasedPricesInformation
     * @return \ArrayType\ArrayOfIncreasedPricesInformation
     */
    public function setIncreasedPricesInformation(array $increasedPricesInformation = array())
    {
        // validation for constraint: array
        if ('' !== ($increasedPricesInformationArrayErrorMessage = self::validateIncreasedPricesInformationForArrayConstraintsFromSetIncreasedPricesInformation($increasedPricesInformation))) {
            throw new \InvalidArgumentException($increasedPricesInformationArrayErrorMessage, __LINE__);
        }
        if (is_null($increasedPricesInformation) || (is_array($increasedPricesInformation) && empty($increasedPricesInformation))) {
            unset($this->IncreasedPricesInformation);
        } else {
            $this->IncreasedPricesInformation = $increasedPricesInformation;
        }
        return $this;
    }
    /**
     * Add item to IncreasedPricesInformation value
     * @throws \InvalidArgumentException
     * @param \StructType\IncreasedPricesInformation $item
     * @return \ArrayType\ArrayOfIncreasedPricesInformation
     */
    public function addToIncreasedPricesInformation(\StructType\IncreasedPricesInformation $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\IncreasedPricesInformation) {
            throw new \InvalidArgumentException(sprintf('The IncreasedPricesInformation property can only contain items of type \StructType\IncreasedPricesInformation, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->IncreasedPricesInformation[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\IncreasedPricesInformation|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\IncreasedPricesInformation|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\IncreasedPricesInformation|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\IncreasedPricesInformation|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\IncreasedPricesInformation|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string IncreasedPricesInformation
     */
    public function getAttributeName()
    {
        return 'IncreasedPricesInformation';
    }
}
