<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for picture StructType
 * @subpackage Structs
 */
class Picture extends AbstractStructBase
{
    /**
     * The id
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $id;
    /**
     * The gpsLatitude
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $gpsLatitude;
    /**
     * The gpsLongitude
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $gpsLongitude;
    /**
     * The anwbCertified
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $anwbCertified;
    /**
     * The order
     * Meta information extracted from the WSDL
     * - use: required
     * @var int
     */
    public $order;
    /**
     * The url
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $url;
    /**
     * The urlHightQuality
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $urlHightQuality;
    /**
     * The ForServiceCategoryName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ForServiceCategoryName;
    /**
     * Constructor method for picture
     * @uses Picture::setId()
     * @uses Picture::setGpsLatitude()
     * @uses Picture::setGpsLongitude()
     * @uses Picture::setAnwbCertified()
     * @uses Picture::setOrder()
     * @uses Picture::setUrl()
     * @uses Picture::setUrlHightQuality()
     * @uses Picture::setForServiceCategoryName()
     * @param int $id
     * @param float $gpsLatitude
     * @param float $gpsLongitude
     * @param bool $anwbCertified
     * @param int $order
     * @param string $url
     * @param string $urlHightQuality
     * @param string $forServiceCategoryName
     */
    public function __construct($id = null, $gpsLatitude = null, $gpsLongitude = null, $anwbCertified = null, $order = null, $url = null, $urlHightQuality = null, $forServiceCategoryName = null)
    {
        $this
            ->setId($id)
            ->setGpsLatitude($gpsLatitude)
            ->setGpsLongitude($gpsLongitude)
            ->setAnwbCertified($anwbCertified)
            ->setOrder($order)
            ->setUrl($url)
            ->setUrlHightQuality($urlHightQuality)
            ->setForServiceCategoryName($forServiceCategoryName);
    }
    /**
     * Get id value
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param int $id
     * @return \StructType\Picture
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !(is_int($id) || ctype_digit($id))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get gpsLatitude value
     * @return float
     */
    public function getGpsLatitude()
    {
        return $this->gpsLatitude;
    }
    /**
     * Set gpsLatitude value
     * @param float $gpsLatitude
     * @return \StructType\Picture
     */
    public function setGpsLatitude($gpsLatitude = null)
    {
        // validation for constraint: float
        if (!is_null($gpsLatitude) && !(is_float($gpsLatitude) || is_numeric($gpsLatitude))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($gpsLatitude, true), gettype($gpsLatitude)), __LINE__);
        }
        $this->gpsLatitude = $gpsLatitude;
        return $this;
    }
    /**
     * Get gpsLongitude value
     * @return float
     */
    public function getGpsLongitude()
    {
        return $this->gpsLongitude;
    }
    /**
     * Set gpsLongitude value
     * @param float $gpsLongitude
     * @return \StructType\Picture
     */
    public function setGpsLongitude($gpsLongitude = null)
    {
        // validation for constraint: float
        if (!is_null($gpsLongitude) && !(is_float($gpsLongitude) || is_numeric($gpsLongitude))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($gpsLongitude, true), gettype($gpsLongitude)), __LINE__);
        }
        $this->gpsLongitude = $gpsLongitude;
        return $this;
    }
    /**
     * Get anwbCertified value
     * @return bool
     */
    public function getAnwbCertified()
    {
        return $this->anwbCertified;
    }
    /**
     * Set anwbCertified value
     * @param bool $anwbCertified
     * @return \StructType\Picture
     */
    public function setAnwbCertified($anwbCertified = null)
    {
        // validation for constraint: boolean
        if (!is_null($anwbCertified) && !is_bool($anwbCertified)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($anwbCertified, true), gettype($anwbCertified)), __LINE__);
        }
        $this->anwbCertified = $anwbCertified;
        return $this;
    }
    /**
     * Get order value
     * @return int
     */
    public function getOrder()
    {
        return $this->order;
    }
    /**
     * Set order value
     * @param int $order
     * @return \StructType\Picture
     */
    public function setOrder($order = null)
    {
        // validation for constraint: int
        if (!is_null($order) && !(is_int($order) || ctype_digit($order))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($order, true), gettype($order)), __LINE__);
        }
        $this->order = $order;
        return $this;
    }
    /**
     * Get url value
     * @return string|null
     */
    public function getUrl()
    {
        return $this->url;
    }
    /**
     * Set url value
     * @param string $url
     * @return \StructType\Picture
     */
    public function setUrl($url = null)
    {
        // validation for constraint: string
        if (!is_null($url) && !is_string($url)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($url, true), gettype($url)), __LINE__);
        }
        $this->url = $url;
        return $this;
    }
    /**
     * Get urlHightQuality value
     * @return string|null
     */
    public function getUrlHightQuality()
    {
        return $this->urlHightQuality;
    }
    /**
     * Set urlHightQuality value
     * @param string $urlHightQuality
     * @return \StructType\Picture
     */
    public function setUrlHightQuality($urlHightQuality = null)
    {
        // validation for constraint: string
        if (!is_null($urlHightQuality) && !is_string($urlHightQuality)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($urlHightQuality, true), gettype($urlHightQuality)), __LINE__);
        }
        $this->urlHightQuality = $urlHightQuality;
        return $this;
    }
    /**
     * Get ForServiceCategoryName value
     * @return string|null
     */
    public function getForServiceCategoryName()
    {
        return $this->ForServiceCategoryName;
    }
    /**
     * Set ForServiceCategoryName value
     * @param string $forServiceCategoryName
     * @return \StructType\Picture
     */
    public function setForServiceCategoryName($forServiceCategoryName = null)
    {
        // validation for constraint: string
        if (!is_null($forServiceCategoryName) && !is_string($forServiceCategoryName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($forServiceCategoryName, true), gettype($forServiceCategoryName)), __LINE__);
        }
        $this->ForServiceCategoryName = $forServiceCategoryName;
        return $this;
    }
}
